from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Boolean, File, Int, String

Flye_Samtools_Mpileup_V0_1_0 = CommandToolBuilder(tool="flye_samtools_mpileup", base_command=["flye-samtools", "mpileup"], inputs=[ToolInput(tag="in_illumina_one_dot_three", input_type=Boolean(optional=True), prefix="--illumina1.3", doc=InputDocumentation(doc="+      quality is in the Illumina-1.3+ encoding")), ToolInput(tag="in_count_orphans", input_type=Boolean(optional=True), prefix="--count-orphans", doc=InputDocumentation(doc="do not discard anomalous read pairs")), ToolInput(tag="in_bam_list", input_type=File(optional=True), prefix="--bam-list", doc=InputDocumentation(doc="list of input BAM filenames, one per line")), ToolInput(tag="in_no_baq", input_type=Boolean(optional=True), prefix="--no-BAQ", doc=InputDocumentation(doc="disable BAQ (per-Base Alignment Quality)")), ToolInput(tag="in_adjust_mq", input_type=Int(optional=True), prefix="--adjust-MQ", doc=InputDocumentation(doc="adjust mapping quality; recommended:50, disable:0 [0]")), ToolInput(tag="in_max_depth", input_type=Int(optional=True), prefix="--max-depth", doc=InputDocumentation(doc="max per-file depth; avoids excessive memory usage [8000]")), ToolInput(tag="in_redo_baq", input_type=Boolean(optional=True), prefix="--redo-BAQ", doc=InputDocumentation(doc="recalculate BAQ on the fly, ignore existing BQs")), ToolInput(tag="in_fast_a_ref", input_type=File(optional=True), prefix="--fasta-ref", doc=InputDocumentation(doc="faidx indexed reference sequence file")), ToolInput(tag="in_exclude_rg", input_type=File(optional=True), prefix="--exclude-RG", doc=InputDocumentation(doc="exclude read groups listed in FILE")), ToolInput(tag="in_positions", input_type=File(optional=True), prefix="--positions", doc=InputDocumentation(doc="skip unlisted positions (chr pos) or regions (BED)")), ToolInput(tag="in_min_mq", input_type=Int(optional=True), prefix="--min-MQ", doc=InputDocumentation(doc="skip alignments with mapQ smaller than INT [0]")), ToolInput(tag="in_min_bq", input_type=Int(optional=True), prefix="--min-BQ", doc=InputDocumentation(doc="skip bases with baseQ/BAQ smaller than INT [13]")), ToolInput(tag="in_region", input_type=String(optional=True), prefix="--region", doc=InputDocumentation(doc="region in which pileup is generated")), ToolInput(tag="in_ignore_rg", input_type=Boolean(optional=True), prefix="--ignore-RG", doc=InputDocumentation(doc="ignore RG tags (one BAM = one sample)")), ToolInput(tag="in_incl_flags", input_type=Int(optional=True), prefix="--incl-flags", doc=InputDocumentation(doc="|INT  required flags: skip reads with mask bits unset []")), ToolInput(tag="in_excl_flags", input_type=Int(optional=True), prefix="--excl-flags", doc=InputDocumentation(doc="|INT  filter flags: skip reads with mask bits set\n[UNMAP,SECONDARY,QCFAIL,DUP]")), ToolInput(tag="in_ignore_overlaps", input_type=Boolean(optional=True), prefix="--ignore-overlaps", doc=InputDocumentation(doc="disable read-pair overlap detection")), ToolInput(tag="in_output", input_type=File(optional=True), prefix="--output", doc=InputDocumentation(doc="write output to FILE [standard output]")), ToolInput(tag="in_output_bp", input_type=Boolean(optional=True), prefix="--output-BP", doc=InputDocumentation(doc="output base positions on reads")), ToolInput(tag="in_output_mq", input_type=Boolean(optional=True), prefix="--output-MQ", doc=InputDocumentation(doc="output mapping quality")), ToolInput(tag="in_output_qname", input_type=Boolean(optional=True), prefix="--output-QNAME", doc=InputDocumentation(doc="output read names")), ToolInput(tag="in_input_fmt_option", input_type=File(optional=True), prefix="--input-fmt-option", doc=InputDocumentation(doc="[=VAL]\nSpecify a single input file format option in the form\nof OPTION or OPTION=VALUE")), ToolInput(tag="in_reference", input_type=File(optional=True), prefix="--reference", doc=InputDocumentation(doc="Reference sequence FASTA FILE [null]")), ToolInput(tag="in_sam_tools", input_type=String(), position=0, doc=InputDocumentation(doc="")), ToolInput(tag="in_m_pile_up", input_type=String(), position=1, doc=InputDocumentation(doc="")), ToolInput(tag="in_in_one_dot_bam", input_type=Int(), position=2, doc=InputDocumentation(doc=""))], outputs=[ToolOutput(tag="out_output", output_type=File(optional=True), selector=InputSelector(input_to_select="in_output", type_hint=File()), doc=OutputDocumentation(doc="write output to FILE [standard output]"))], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Flye_Samtools_Mpileup_V0_1_0().translate("wdl", allow_empty_container=True)

